#link "IccProfile.dll"
#include "sys:Info.ms"
#include "sys:TextResponse.ms";
#include "sys:FileUtilities.ms";

var thisScriptVFS = ""; ///"uaz2:/"

//-----------------------------------------------------------------------------

function ShowScriptName()
{
	SetTextResponse(getScriptFileName());
}
var sn = ShowScriptName;
//-----------------------------------------------------------------------------

function ShowFontList()
{
	SetTextResponse(System.getFontList());
}
var fonts = ShowFontList;
//-----------------------------------------------------------------------------

function ShowVfsList()
{
	SetTextResponse(System.getVFSInfo());
}
var vfs = ShowVfsList;
//-----------------------------------------------------------------------------

function ShowSystem()
{
	var os = System.getOSName();
	var text = "OS Name: " + os + "\n" + "CPU Name: " + System.getCPUName();
	if (os == "Win32")
	{
		text += "\nTotal System Memory: " + Math.round(System.getTotalMemory() / 1073741824) + " GB\nVideo Adapters: ";
		var va = System.getVideoAdapters();
		for (var i in va)
			text += (i > 0 ? ", " : "") + va[i].name + " w/ " + Math.round(va[i].totalVRam / 1048576) + " MB";
		text += "\n";
	}
	SetTextResponse(text);
}
var s = ShowSystem;
//-----------------------------------------------------------------------------

function ShowPipeInfo() // to call this from the browser: http://localhost/mgen/Info2.ms?args="FileInfo","merchandizer:sample_v.jpg"
{
	var m = new Media();
	var textInfo = "Pipe info:\n" + m.getInfo() + "\n";
	SetTextResponse(textInfo);
}
var pi = ShowPipeInfo;
//-----------------------------------------------------------------------------

function ShowHeaders()
{
	var headers = GetHeaders();
	if (headers.length == 0)
		headers = "No headers";
	SetTextResponse(headers);
}
var h = ShowHeaders;
//-----------------------------------------------------------------------------

function ShowProperty(propName) // call this from the browser, e.g: http://localhost/mgen/Info2.ms?args="Property","local.LogLevel"
{
	var propValue = getPropertyValue(propName);
	SetTextResponse(propName + " = " + propValue);
}
function p() {
	var name = req.getParameter("name");
	ShowProperty(name);
}
//-----------------------------------------------------------------------------

function ShowFileInfo(filePath) // call this from the browser, e.g: http://localhost/mgen/Info2.ms?args="FileInfo","merchandizer:sample_v.jpg"
{
	var file = new File(filePath);
	var textInfo = filePath;
	if (file.isDirectory()) {
		var fileList = file.list();
		textInfo += " (" + fileList.length + " entries)\n\n";
		for (var f in fileList) {
			textInfo += fileList[f].getFileName();
			if (fileList[f].isFile()) {
				var type = Media.getTypeFromExtension(fileList[f].getFileExtension());
				if (type) {
					textInfo += ": ";
					var fileInfo = Media.getFileInfo(name @ fileList[f].getFilePath());
					for (var key in fileInfo)
						textInfo += key + ": " + fileInfo[key] + ", ";
					textInfo = textInfo.slice(0, -2);
				}
			}
			else if (fileList[f].isDirectory()) {
				textInfo += "/";
			}
			textInfo += "\n";
		}
	}
	else {
		textInfo += "\n\n";
		var fileInfo = Media.getFileInfo(name @ filePath);
		for (var key in fileInfo)
			textInfo += key + ":" + fileInfo[key] + "\n";
		
		textInfo += "\n";
		textInfo += "path: " + file.getFilePath() + "\n";
		textInfo += "last accessed: " + (new Date(file.getLastAccessed() * 1000)) + " (" + file.getLastAccessed() + ")\n";
		textInfo += "last modified: " + (new Date(file.getLastModified() * 1000)) + " (" + file.getLastModified() + ")\n";
		textInfo += "size: " + file.getSize() + " bytes\n";
		textInfo += "is shared: " + file.isShared() + "\n";
		textInfo += "length: " + file.length() + " lines\n";
		
		textInfo += "\n";
		var m = new Media();
		m.load({name: filePath});
		textInfo += "frame count: " + m.getFrameCount() + "\n";
		textInfo += "width: " + m.getWidth() + "\n";
		textInfo += "height: " + m.getHeight() + "\n";
		textInfo += "horizontal resolution: " + m.getResHorizontal() + "\n";
		textInfo += "vertical resolution: " + m.getResVertical() + "\n";
		textInfo += "image format: " + m.getImageFormat() + "\n";
		textInfo += "pixel format: " + m.getPixelFormat() + "\n";
		textInfo += "bits per sample: " + m.getBitsPerSample() + "\n";
		textInfo += "bytes per pixel: " + m.getBytesPerPixel() + "\n";
		textInfo += "samples per pixel: " + m.getSamplesPerPixel() + "\n";
		textInfo += "palette size: " + m.getPaletteSize() + "\n";
		textInfo += "average color: 0x" + m.getAverageColor().toString(16) + "\n";
		textInfo += "popular color: 0x" + m.getPopularColor().toString(16) + "\n";
		textInfo += "exif metadata: " + m.getMetadata("Exif") + "\n";
	}
	SetTextResponse(textInfo);
}
function fi() {
	var filePath = req.getParameter("path");
	ShowFileInfo(filePath);
}
//-----------------------------------------------------------------------------

function GetFileList(inFolder, separator)
{
    if (!separator) separator = "\n";
    var fileList = GetFileListWithSeparator(inFolder, separator)
    SetTextResponse(fileList);
}
function fl() {
	var path = req.getParameter("path");
	var sep = req.getParameter("sep");
	GetFileList(path, sep);
}
//-----------------------------------------------------------------------------

function ShowFileFormats() // call this from the browser, e.g: http://localhost/mgen/Info2.ms?args="FileFormats"
{
	var fileFormats = Media.getFileFormats();
	var textInfo = "File formats:\n";
	textInfo += "-------------------------\n"
	for (var i in fileFormats) {
		for (var key in fileFormats[i]) {
			if (key == "flags") {
				var flags = fileFormats[i][key];
				textInfo += "flags: ";
				if (flags & Media.FormatLoad)
					textInfo += "load ";
				if (flags & Media.FormatSave)
					textInfo += "save ";
				if (flags & Media.FormatCmykSave)
					textInfo += "cmyk-save ";
				if (flags & Media.FormatExifLoad)
					textInfo += "exit-load ";
				if (flags & Media.FormatIPTCLoad)
					textInfo += "iptc-load ";
				textInfo += "\n";
			}
			else
				textInfo += key + ": " + fileFormats[i][key] + "\n";
		}
		textInfo += "-------------------------\n"
	}
	SetTextResponse(textInfo);
}
var ff = ShowFileFormats;
//-----------------------------------------------------------------------------

function ListIccProfiles()
{
	var allColorSpaces = IccProfile.RGB | IccProfile.CMYK | IccProfile.LAB | IccProfile.XYZ | IccProfile.GRAY | IccProfile.ALPHA | IccProfile.PALETTE | IccProfile.HLS | IccProfile.HSV;
	var allColorClasses = IccProfile.MONITOR | IccProfile.SCANNER | IccProfile.PRINTER | IccProfile.LINK | IccProfile.ABSTRACT | IccProfile.COLORSPACE | IccProfile.NAMEDCOLOR | IccProfile.UNKNOWN;
	var profs = IccProfile.list(allColorSpaces, allColorClasses); // or -1, -1
	var txt = new TextResponse();
	txt.append(profs.length + " ICC profiles:\n\n");
	for (var i = 0; i < profs.length; ++i)
	{
		txt.append(profs[i] + "\n");
		var currProf = new IccProfile(profs[i]);
		txt.append("	name: " + currProf.getName() + "\n");
		txt.append("	path: " + currProf.getPath() + "\n");
		txt.append("	class: " + currProf.getClass() + "\n");
		txt.append("	colorspace: " + currProf.getColorspace() + "\n");
		txt.append("	connectionspace: " + currProf.getConnectionspace() + "\n");
		currProf.close();
	}
	resp.setObject(txt, RespType.Streamed);
}
var icc = ListIccProfiles;
//-----------------------------------------------------------------------------

function ListObjectsAndProperties()
{
	var text = "";
	text += "Cubic.prototype: \n" + getObjectProperties(Cubic.prototype) + "\n\n";
	text += "File.prototype: \n" + getObjectProperties(File.prototype) + "\n\n";
	///text += "FileSpec: \n" + getObjectProperties(FileSpec) + "\n\n";
	text += "Global: \n" + getObjectProperties(Global) + "\n\n";
	text += "HttpRequest.prototype: \n" + getObjectProperties(HttpRequest.prototype) + "\n\n";
	text += "HttpResponse.prototype: \n" + getObjectProperties(HttpResponse.prototype) + "\n\n";
	text += "LogFile: \n" + getObjectProperties(LogFile) + "\n\n";
	text += "Media: \n" + getObjectProperties(Media) + "\n\n";
	text += "_MR_Metadata.prototype: \n" + getObjectProperties(_MR_Metadata.prototype) + "\n\n";
	text += "MutexHandle.prototype: \n" + getObjectProperties(MutexHandle.prototype) + "\n\n";
	///text += "Stream: \n" + getObjectProperties(Stream) + "\n\n";
	text += "System: \n" + getObjectProperties(System) + "\n\n";
	text += "req._prototype: \n" + getObjectProperties(req._prototype) + "\n\n";
	text += "resp._prototype: \n" + getObjectProperties(resp._prototype) + "\n\n";
	text += "String.prototype: \n" + getObjectProperties(String.prototype) + "\n\n";
	text += "Date.prototype: \n" + getObjectProperties(Date.prototype) + "\n\n";
	SetTextResponse(text);
}
var op = ListObjectsAndProperties;
//-----------------------------------------------------------------------------

function clearCached() {
	var mrl = req.getParameter("mrl") || "/mgen/mediaRichTest.ms";
	var cleared = clearCachedMRL(mrl);
	SetTextResponse(mrl + " - " + (cleared ? "cleared" : "not found"));
}
var cc = clearCached;
//-----------------------------------------------------------------------------

function main(info4what, arg2, arg3)
{
	var thisScript = "/mgen/" + thisScriptVFS + getScriptFileName(); // getScriptFileName() = "Info2.ms";
	switch (info4what)
	{
		case "FileInfo": ShowFileInfo(arg2); break;
		case "FileList": GetFileList(arg2, arg3); break;
		case "Fonts": ShowFontList(); break;
		case "Formats": ShowFileFormats(arg2); break;
		case "Headers": ShowHeaders(); break;
		case "Objects": ListObjectsAndProperties(); break;
		case "PipeInfo": ShowPipeInfo(); break;
		case "Profiles": ListIccProfiles(); break;
		case "Property": ShowProperty(arg2); break;
		case "System": ShowSystem(); break;
		case "VFSs": ShowVfsList(); break;
		default: SetHTMLResponse("Choose one of: <br /><br />" +
			"<a href='" + thisScript + "?args=%22FileList%22,%22merchandizer:/unizoom%22'>FileList</a>&nbsp;&nbsp;&nbsp;" +
				"<a href='" + thisScript + "?f=fl&path=merchandizer:/unizoom'>alt syntax</a><br />" + //read:
			"<a href='" + thisScript + "?args=%22FileInfo%22,%22mediaRichTest.jpg%22'>FileInfo</a>&nbsp;&nbsp;&nbsp;" +
				"<a href='" + thisScript + "?f=fi&path=mediaRichTest.jpg'>alt syntax</a><br />" + 
			"<a href='" + thisScript + "?args=%22Property%22,%22local.HotFolderNoActivityDelay%22'>Property</a>&nbsp;&nbsp;&nbsp;" +
				"<a href='" + thisScript + "?f=p&name=local.HotFolderNoActivityDelay'>alt syntax</a><br />" + 
			"<br />" +
			"<a href='" + thisScript + "?args=%22Fonts%22'>Fonts</a><br />" + 
			"<a href='" + thisScript + "?args=%22Formats%22'>Formats</a><br />" + 
			"<a href='" + thisScript + "?args=%22Headers%22'>Headers</a><br />" + 
			"<a href='" + thisScript + "?args=%22Objects%22'>Objects</a><br />" + 
			"<a href='" + thisScript + "?args=%22PipeInfo%22'>PipeInfo</a><br />" + 
			"<a href='" + thisScript + "?args=%22Profiles%22'>Profiles</a><br />" + 
			"<a href='" + thisScript + "?args=%22System%22'>System</a><br />" + 
			"<a href='" + thisScript + "?args=%22VFSs%22'>VFSs</a><br />");
	}
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

function test() {
	///SetTextResponse(getScriptFileName());
	///SetTextResponse("vp:".slice(0,-1));
	var mrl = "/mgen/mediaRichTest.ms";
	SetTextResponse(mrl + " - cleared " + clearCachedMRL(mrl));
}
//-----------------------------------------------------------------------------

function test2() {
	///SetTextResponse(getScriptFileName());
	///SetTextResponse("vp:".slice(0,-1));
	var kRoot = "vp:";
	SetTextResponse("/" + kRoot.slice(0,-1) + "/UserData/Cache/p2e");
	
}