var interestingWindowsFonts = "Segoe Script,Gabriola,Andalus,Lucida Calligraphy,Lucida Handwriting,Magneto,Matura MR Script,Mistral,Monotype Corsiva,Blackadder JJC,Bradley Hand IT,Brush Script MT,Chiller,Curlz MT,Eduardian Scripts,Forte,Freeestyle Script,French Script MJ,Gigi,Harlow Solid,Informal Roman,Segoe Print,Segoe Script,Viner Hand ITC,Vivaldi,Vladimir Script,MV Boli Old English Text,Palace script MT,Papyrus,Parchment,Pristina,Rage Italic,Ravie,Script MJ Bold,Jokerman,Arial";

function main()
{
	var text =      getArgWithDefault("text",      "MediaRich is running");
	var font =      getArgWithDefault("font",      System.getOSName() == "MacOSX" ? "Zapfino" : firstAvailableFont(interestingWindowsFonts));
	var size =      getArgWithDefault("size",      60);
	var color =     getArgWithDefault("color",     getRandomColor()); // 0x0000ff;
	var fillColor = getArgWithDefault("fillColor", 0xffffff);
	var dpi =       getArgWithDefault("dpi",       100); // Windows only
	var angle =     getArgWithDefault("angle",     getRandomAngle()); // -10;
	var kern =      getArgWithDefault("kern",      true);
	var smooth =    getArgWithDefault("smooth",    true);
	var rtype =     getArgWithDefault("rtype",     "RGB"); // RGB, RGBA, CMYK, CMYKA, Pal-8, Gray, RGB-15, RGB-16, RGBA-16, RGB-18, Alpha-8, HLS, HSV
	
	var m = new Media();
	m.makeText(text @ text, font @ font, size @ size, color @ color, fillColor @ fillColor, 
	           dpi @ dpi, angle @ angle, kern @ kern, smooth @ smooth, rtype @ rtype);
	m.save(type @ "jpeg");
}

//-----------------------------------------------------------------------------

function getArgWithDefault(name, dflt)
{
	var r = req.getParameter(name);
	return r ? r : dflt;
}

function firstAvailableFont(fontList) {
	var fontArray = fontList.split(",");
	for (var f in fontArray)
		if (System.fontExists(fontArray[f]))
			return fontArray[f];
	return "Lucida Console";	// this is the only font available by default on the Docker Server 2019 IIS
}

function getRandomColor() {
	return getRandomIntInclusive(0, 0xffffff);
}

function getRandomAngle() {
	return getRandomIntInclusive(0, 360);
}

// Returns a random integer between min (included) and max (included)
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
function getRandomIntInclusive(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

