function numTo4cc(num)
{
	// if we got a string, just return it.
	if (typeof(num) == "string")
	{
		return num;
	}
	
	// convert each part to char code.
	var v1 = (num >> 24) & 0xff;
	var v2 = (num >> 16) & 0xff;
	var v3 = (num >> 08) & 0xff;
	var v4 = (num >> 00) & 0xff;
	
	// escape non ascii chars so 0 -> "\\0\\0\\0\\0\\0";
	var s = (v1 < 32 || v1 > 127) ? ("\\" + v1.toString(16)) : String.fromCharCode(v1);
	s +=    (v2 < 32 || v2 > 127) ? ("\\" + v2.toString(16)) : String.fromCharCode(v2);
	s +=    (v3 < 32 || v3 > 127) ? ("\\" + v3.toString(16)) : String.fromCharCode(v3);
	s +=    (v4 < 32 || v4 > 127) ? ("\\" + v4.toString(16)) : String.fromCharCode(v4);

	return s;
}

function numFrom4cc(str)
{
	var r = 0;
	var len = str.length;
	r |= ((len > 0)? str.charCodeAt(0) : 32) << 24;
	r |= ((len > 1)? str.charCodeAt(1) : 32) << 16;
	r |= ((len > 2)? str.charCodeAt(2) : 32) << 8;
	r |= ((len > 3)? str.charCodeAt(3) : 32);
	return r;
}
