
//-----------------------------------------------------------------------------

ColumnsFormatter = function(columnSeparatorInInputLines, numSpacesBetweenColumnsInOutput)
{
    this.lines = new Array();
    if (!columnSeparatorInInputLines)
        columnSeparatorInInputLines = "\t";
    if (!numSpacesBetweenColumnsInOutput)
        numSpacesBetweenColumnsInOutput = 4;
    this.sep = columnSeparatorInInputLines;
    this.numSpaces = numSpacesBetweenColumnsInOutput;
}
ColumnsFormatter.prototype =
{
    addLine : function(line)
    {
        this.lines[this.lines.length] = line;
    },
    
    addMultiLineString : function(str)
    {
        this.lines = str.split("\n");
    },
    
    reformatLines : function()
    {
        var cols = new Array();
        var maxColLen = new Array();
        for (var i = 0; i < this.lines.length; i++)
        {
            cols[i] = this.lines[i].split(this.sep);
            for (var c = 0; c < cols[i].length; c++)
            {
                if (maxColLen.length <= c)
                    maxColLen[c] = 0;
                if (maxColLen[c] < cols[i][c].length)
                    maxColLen[c] = cols[i][c].length;
            }
        }
        var newLines = new Array();
        ///var startTime = new Date().getTime();
        for (var i = 0; i < this.lines.length; i++)
        {
            var line = cols[i][0];
            for (var c = 1; c < cols[i].length; c++)
            {
                var numSpacesToAdd = maxColLen[c-1] - cols[i][c-1].length + this.numSpaces;
                for (var s = 0; s < numSpacesToAdd; s++)
                    line += " ";
                ///line += "                    ".substr(0, numSpacesToAdd); // little faster, but may be short
                line += cols[i][c];
            }
            newLines.push(line);
        }
        ///print(this.lines.length + " lines - " + (new Date().getTime() - startTime)/1000 + " secs\n");
        return newLines.join("\n");
    }
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

function IsFolderAndNotIgnored(fileObj)
{
    var fileName = fileObj.getFileName();
    return (fileObj.isDirectory() && fileName.charAt(0) != '.');
}
//-----------------------------------------------------------------------------

function IsFileAndNotIgnored(fileObj)
{
    var fileName = fileObj.getFileName();
    return (fileObj.isFile() && fileName.charAt(0) != '.' && fileName != "Thumbs.db");
}
//-----------------------------------------------------------------------------

function GetFileListWithSeparatorWoExt(inFolder, separator, withoutExt)
{
    var files = (new File(inFolder)).list();
    var fileList = "";
    for (var i = 0 ; i < files.length ; i++)
    {
        var file = files[i];
        var fileName = file.getFileName();
        if (IsFileAndNotIgnored(file))
        {
            if (fileList != "")
                fileList += separator;
            if (withoutExt)
                fileName = fileName.substr(0, fileName.lastIndexOf("."))
            fileList += fileName;
        }
    }
    return fileList;
}
//-----------------------------------------------------------------------------

function GetFileListWithSeparator(inFolder, separator)
{
    return GetFileListWithSeparatorWoExt(inFolder, separator, false)
}
//-----------------------------------------------------------------------------

function GetFileList(inFolder)
{
    return GetFileListWithSeparator(inFolder, '\n')
}
//-----------------------------------------------------------------------------

function FindFileIgnoreExtension(fileNameWithoutExt, inFolder)
{
    var folder = new File(inFolder);
    var list = folder.list();
    for (var i = 0; i < list.length; i++)
    {
        var fullFileName = list[i].getFileName();
        var fileNameForCompare = fullFileName;
        var lastDotIndex = fullFileName.lastIndexOf('.');
        if (lastDotIndex > 0)
            fileNameForCompare = fullFileName.substring(0, lastDotIndex);
        if (fileNameForCompare == fileNameWithoutExt)
            return fullFileName;
    }
    return "";
}
//-----------------------------------------------------------------------------

