_MR_executeProfileScript();

function _MR_executeProfileScript()
{
    var profileStr = req.getParameter("p");
    if (profileStr == undefined)
        return;
        
    var image = resp.getMedia();

    var saveType = "jpeg";
    var saveParams = resp.getSaveParameters();    
    if (typeof(saveParams) == "object" && saveParams.type != undefined)
        saveType = saveParams.type;

    // if the image type is not jpeg, gif or png, then do nothing
    // this prevents intermediate images from being altered.
    if (saveType != "jpeg" && saveType != "jpg" && saveType != "gif" && saveType != "png")
        return;

    profileStr = _MR_mapProfiles(profileStr);
    
    // split the arguments into two pieces
    var params = profileStr.split(':');
    var bandwidth = 4;
    var bitDepth = 32;

    if (params.length >= 2)
    {
        bitDepth = parseInt(params[1]);

        if (isNaN(bitDepth) || bitDepth < 1 || bitDepth > 32)
            bitDepth = 32;
    }
    
    if (params.length >= 1)
    {
        bandwidth = parseInt(params[0]);
        // check for defaults    
        // now the image is either a jpeg or gif
        if (isNaN(bandwidth) || bandwidth < 0 || bandwidth > 4)
            bandwidth = 4;
    }
 
    var isJpeg = (saveType == "jpeg" || saveType == "jpg");
    var isPng = (saveType == "png");

    // if the image is jpeg, check if we want to change to gif
    if (isJpeg)
    {
        if (bitDepth <= 8)
        {
            // change type to gif for 8-bit and smaller
            isJpeg = false;
            isPng = false;
        }
    }

    // clear existing save arguments.
    saveParams = {};

    // are we still jpeg
    if (isJpeg)
    {
        var quality = (bandwidth + 1) * 20;
        if (quality > 95)
            quality = 95;
        saveParams.quality = quality;
        saveParams.type = "jpeg";
    }
    //  Are we Png?
    else if (isPng)
    {
        // Compression range is 0 to 9.  -1 is default compression.
        // PNG is never lossy.  Therefore this setting simply
        // effects how fast and how small the image is saved.
        var quality = 8 - ((bandwidth / 4.0) * 8); // 9 is too slow
        saveParams.CompressionLevel = quality;
       
        // reduce the image to the specified number of colors.
        if (bitDepth < 8) 
        {
            var numColors = Math.pow(2, bitDepth);

            if (numColors > 4)
            {
                image.reduce(colors @ numColors, dither @ 8, dithertop @ 7);
            }
            else if (numColors == 4)
            {
                image.convert(rtype @ "Grayscale", dither @ 3);
                image.reduce(colors @ numColors, dither @ 3);
            }
            else
            {
                image.reduce(bw @ true, dither @ 9, dithertop @ 9);
            }
        }
        else
        {
            image.reduce(colors @ 256, dither @ 8, dithertop @ 7);
        }
        saveParams.type = "png";
    }
    else
    {
        // handle gif save
        // reduce the image to the specified number of colors.
        if (bitDepth < 8)
        {
            var numColors = Math.pow(2, bitDepth);

            if (numColors > 4)
            {
                image.reduce(colors @ numColors, dither @ 8, dithertop @ 7);
            }
            else if (numColors == 4)
            {
                image.convert(rtype @ "Grayscale", dither @ 3);
                image.reduce(colors @ numColors, dither @ 3);
            }
            else
            {
                image.reduce(bw @ true, dither @ 9, dithertop @ 9);
            }
        }
        else
        {
            image.reduce(colors @ 256, dither @ 8, dithertop @ 7);
        }
        //  set the type to gif.
        saveParams.type = "gif";
    }
    
    resp.setSaveParameters(saveParams);
}


//  map the above names into the matching profiles.
function _MR_mapProfiles(str)
{
    var DeviceNames = new Array("Palm", "Visor", "Jornada", "IPaq", 
                                "Casio", "Prism", "ER209i", "SCH-8500", 
                                "T250");
    var ProfileTypes = new Array("4:2", "4:2", "4:4", "4:4", 
                                 "4:32", "4:4", "4:32", "4:1", 
                                 "4:2");

    if (str.charAt(0) > '9')
    {
        for (i = 0; i < DeviceNames.length; i++)
        {
            if (str == (DeviceNames[i]))
                return ProfileTypes[i];
        }
    }
    return str;
}
