/*==============================================================================
*
* File:         mimeTypes.ms
*
* Contains:
* Code to convert file extensions to MIME types.
*
* Written by:   josh_devan
*
* Copyright:    Copyright (C) 2002 Equilibrium, Inc. All rights reserved.
*
*=============================================================================*/


// ----------------------------------- declares --------------------------------

var _MR_mimeTypes =
{
    pdf:    "application/pdf",
    ai:     "application/postscript",
    ps:     "application/postscript",
    eps:    "application/postscript",
    rtf:    "application/rtf",
    rm:     "application/vnd.rn-realmedia",
    js:     "application/x-javascript",
    flv:    "application/x-shockwave-flash", //also flv-application/octet-stream
    swf:    "application/x-shockwave-flash",
    zip:    "application/zip",
    css:    "text/css",
    htm:    "text/html",
    html:   "text/html",
    txt:    "text/plain",
    au:     "audio/basic",
    snd:    "audio/basic",
    mid:    "audio/mid",
    m4a:    "audio/mp4a-latm",
    m4p:    "audio/mp4a-latm",
    mpga:   "audio/mpeg",
    mp2:    "audio/mpeg",
    mp3:    "audio/mpeg",
    aif:    "audio/x-aiff",
    aifc:   "audio/x-aiff",
    aiff:   "audio/x-aiff",
    m3u:    "audio/x-mpegurl",
    ra:     "audio/x-pn-realaudio",
    ram:    "audio/x-pn-realaudio",
    wav:    "audio/x-wav",
    bmp:    "image/bmp",
    cgm:    "image/cgm",
    fpx:    "image/vnd.fpx",
    gif:    "image/gif",
    jp2:    "image/jp2",
    jpg:    "image/jpeg",
    jpeg:   "image/jpeg",
    jpe:    "image/jpeg",
    jfif:   "image/pjpeg",
    pcx:    "image/x-pcx",
    pct:    "image/pict",
    pic:    "image/pict",
    pict:   "image/pict",
    png:    "image/png",
    svg:    "image/svg+xml",
    tif:    "image/tiff",
    tiff:   "image/tiff",
    pnt:    "image/x-macpaint",
    pntg:   "image/x-macpaint",
    mac:    "image/x-macpaint",
    pnm:    "image/x-portable-anymap",
    pnm:    "image/x-portable-pbm",
    pnm:    "image/x-portable-pgm",
    pnm:    "image/x-portable-ppm",
    psd:    "image/x-psd",
    qti:    "image/x-quicktime",
    qtif:   "image/x-quicktime",
    rgb:    "image/x-rgb",
    tga:    "image/x-xbitmap",
    xpm:    "image/x-xpixmap",
    xwd:    "image/x-xwindowdump",
    xbm:    "image/x-tga",
    wbmp:   "image/vnd.wap.wbmp",
    _3gp:   "video/3gpp", // can't start with a digit
    m4v:    "video/mp4",
    mp2:    "video/mpeg",
    mp4:    "video/mp4",
    mpa:    "video/mpeg",
    mpe:    "video/mpeg",
    mpeg:   "video/mpeg",
    mpg:    "video/mpeg",
    mov:    "video/quicktime",
    qt:     "video/quicktime",
    mxu:    "video/vnd.mpegurl",
    m4u:    "video/vnd.mpegurl",
    dv:     "video/x-dv",
    dif:    "video/x-dv",
    avi:    "video/x-msvideo",
    wmv:    "video/x-ms-wmv"
};


// ----------------------------------- functions -------------------------------

/*----------------------------------------------------------------------------
*
* Function: _MR_getMimeTypeFromExtension
*
* Description:
* Returns the MIME type for the given file extension (if it is in the list of
* known extensions above).
*
* Parameters:
* string ext        -> File extension
*
* Return:
* string            <- MIME type (or undefined if unknown extension).
*
------------------------------------------------------------------------------*/

function _MR_getMimeTypeFromExtension(ext)
{
    if (/^[0-9].*/.test(ext)) // can't start with a digit
    	ext = "_" + ext;
    return _MR_mimeTypes[ext];
}
